﻿Module Module_ButtonAutorepeat

    Private WithEvents Timer1 As New System.Windows.Forms.Timer()
    Private InitialTime As Int32 = 500
    Private RepeatTime As Int32 = 25
    Private mAction As String = ""

    Friend Sub AutorepeatStart(ByVal Action As String)
        ' --------------------------------------------------------- exec the action a first time
        mAction = Action
        ExecAction()
        ' --------------------------------------------------------- delay and repeat settings from system keyboard
        InitialTime = (SystemInformation.KeyboardDelay + 1) * 250
        RepeatTime = 550 \ (SystemInformation.KeyboardSpeed + 1)
        ' --------------------------------------------------------- start timer
        Timer1.Interval = InitialTime
        Timer1.Enabled = True
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles Timer1.Tick
        ' -----------------------------------------
        If Control.MouseButtons = MouseButtons.None Then
            Timer1.Enabled = False
            Return
        End If
        ' -----------------------------------------
        If Timer1.Interval = InitialTime Then
            Timer1.Interval = RepeatTime
        End If
        ' -----------------------------------------
        ExecAction()
    End Sub

    Private Sub ExecAction()
        Select Case mAction.ToUpper
            Case "UNDO"
                If Not Form2.TextBox1.Editor_CanUndo Then Timer1.Enabled = False
                Form2.TextBox1.ExecUndo()
                Form2.TextBox1.Focus()
            Case "REDO"
                If Not Form2.TextBox1.Editor_CanRedo Then Timer1.Enabled = False
                Form2.TextBox1.ExecRedo()
                Form2.TextBox1.Focus()
        End Select
    End Sub

End Module
